#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#define BASIC_CHAR_DD_DEVICE_NAME    "/dev/basic_char_device"

int main(void)
{
    int dev;

    printf("[APP] device file open start\n");
    dev = open(BASIC_CHAR_DD_DEVICE_NAME, O_RDWR|O_NDELAY);
    if(dev < 0)
    {
        printf("device file open error !!\n");
        return -1;
    }
    printf("[APP] device open success: %d\n", dev);

    printf("[APP] read function call start\n");
    read(dev, 0x10, 0x11);

    printf("[APP] write function call start\n");
    write(dev, 0x20, 0x21);

    printf("[APP] ioctl function call start\n");
    ioctl(dev, 0x30, 0x31);

    printf("[APP] device file close start\n");
    close(dev);

    printf("[APP] device file close end\n");
    return 0;
}
