/*
 * hello.c
 */
#include <linux/init.h>
#include <linux/module.h>
MODULE_LICENSE("Dual BSD/GPL");

static int hello_init(void)
{
	printk(KERN_ALERT   "[embeddedcrazyboys] Init HelloWorld module\n");
	printk(KERN_EMERG   "EMERG log <0>\n");
	printk(KERN_ALERT   "ALERT log <1>\n");
	printk(KERN_CRIT    "CRIT log <2>\n");
	printk(KERN_ERR     "ERR log <3>\n");
	printk(KERN_WARNING "WARNING log <4>\n");
	printk(KERN_NOTICE  "NOTICE log <5>\n");
	printk(KERN_INFO    "INFO log <6>\n");
	printk(KERN_DEBUG   "DEBUG log <7>\n");
	printk("No Log level ...\n");
	return 0;
}

static void hello_exit(void)
{
	printk(KERN_ALERT "[embeddedcrazyboys] Exit HelloWorld module\n");
}

module_init(hello_init);
module_exit(hello_exit);
